package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;

import com.ekexiu.portal.po.ResearchAreaLog;
import com.ekexiu.portal.pojo.EditResearchAreaLog;

@DAO
public abstract class ResearchAreaLogDao {
	
	@Insert
	public abstract int insert(Connection con,ResearchAreaLog log) throws SQLException;
	
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId,String opreteProfessorId,String caption)throws SQLException;
	
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId,String caption)throws SQLException;
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId)throws SQLException;
	
	public List<EditResearchAreaLog> query(Connection con,String professorId) throws SQLException{
        int _m_1 = 1;
        String sql = "SELECT OPRETE_PROFESSOR_ID,CREATE_TIME,PROFESSOR_ID,CAPTION FROM RESEARCH_AREA_LOG WHERE PROFESSOR_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,professorId);
            ResultSet rs = ps.executeQuery();
            try{
                List<EditResearchAreaLog> _result = new ArrayList<EditResearchAreaLog>();
                while(rs.next()){
                	EditResearchAreaLog log =  new EditResearchAreaLog();
                	log.setOpreteProfessorId(rs.getString(1));
                	log.setCreateTime(rs.getString(2));
                	log.setProfessorId(rs.getString(3));
                	log.setCaption(rs.getString(4));
                    _result.add(log);
                }
                return _result;
            }finally{
                try{rs.close();}catch(Exception _m_2){}
            }
        }finally{
            try{ps.close();}catch(Exception _m_3){}
        }
    }

}
