package com.ekexiu.portal.job;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

import org.jfw.apt.annotation.Bean;
import org.jfw.util.bean.AfterBeanFactory;
import org.jfw.util.bean.BeanFactory;

@Bean
public class TaskJob implements AfterBeanFactory {
	
	@Override
	public void handle(BeanFactory bf) throws Throwable {
	
		TaskJobEntry tje = (TaskJobEntry) bf.getBean("com_ekexiu_portal_job_TaskJobEntry");
		long delayTime = tje.getDelayTime();
		long task = getTimeMillis(tje.getTaskTime());
		long taskTime = task - System.currentTimeMillis();
		taskTime = taskTime > 0 ? taskTime : delayTime + taskTime;
		
        ScheduledExecutorService service = Executors.newSingleThreadScheduledExecutor();
        // 第二个参数为首次执行的延时时间，第三个参数为定时执行的间隔时间  
//        service.scheduleAtFixedRate(tje, 1, 7200, TimeUnit.SECONDS);
        service.scheduleAtFixedRate(tje, taskTime, delayTime, TimeUnit.MILLISECONDS);
	}
	private static long getTimeMillis(String time) {  
	    try {  
	        DateFormat dateFormat = new SimpleDateFormat("yy-MM-dd HH:mm:ss");  
	        DateFormat dayFormat = new SimpleDateFormat("yy-MM-dd");  
	        Date curDate = dateFormat.parse(dayFormat.format(new Date()) + " " + time);  
	        return curDate.getTime();  
	    } catch (ParseException e) {  
	        e.printStackTrace();  
	    }  
	    return 0;  
	}
	
}
